/**
 * Contains dual classes for standard Java classes and some JUnit classes.
 * Instances of these classes are provided by the JUnit RunListener and they must
 * be moved from JPF VM to the host VM to be accessible by the upper levels
 * of UnitCheck (e.g. exception details must be printed a test failure occurs).
 * <p>
 * Custom dual classes are used because JPF MJI interface allows to access instances
 * of modeled classes using fields (calling methods is an experimental feature).
 * Not to rely on the names of fields used in the implementations of standard Java
 * classes (e.g. Throwable), a custom dual class (e.g. ThrowableHolder) is created.
 * Such a dual class can be then accessed by field names without a fear that the change
 * in the field names of standard classes will break the functionality.
 * <p>
 * An instance of a standard class is transformed to an instance of a custom dual class
 * in {@link cz.kebrt.unitcheck.junit.TestReportListener}. Afterwards, it is accessed
 * in native methods of the corresponding MJI peer class
 * {@link cz.kebrt.unitcheck.jpf.JPF_cz_kebrt_unitcheck_junit_TestReportListener}
 * and a new instance of the former class is then created from the dual class.
 * As a result, the upper levels of UnitCheck work with standard classes, not the dual
 * ones.
 */
package cz.kebrt.unitcheck.junit.holder;

